REM   Program:       uudecv10.bas (UUDECODE version 1.0)
REM                  COPYRIGHT (C) 1995 Russell W. Dixon.
REM                  All Rights Reserved.
REM   Author:        Russell W. Dixon  MATHWEASEL@AOL.COM
REM   Purpose:       A small "dumb" uudecoder that is written in qbasic and
REM                  is capable of being sent through E-mail as a text file.
REM   Cost:          This program is available for unlimited trial use at
REM                  no charge.  If you find this program useful and worthy
REM                  please send $1.00 to:
REM                  Russell W. Dixon  Rt.1 Box 84-C  Sterlington, LA 71280
REM                  (This money will be used to set up a college fund for
REM                   my children, if I can ever afford to have them.)
REM   Instructions:  Download this message to your local hard drive.
REM                  Save as UUDECODE.BAS  From the DOS prompt in the
REM                  subdirectory containing this file:
REM                  1. Type QBASIC /RUN UUDECODE
REM                  2. Enter the path and filename of the file to be
REM                     decoded.  (EX:  C:\TEMP\FILENAME)
REM                  3. Type  ALT-X  to exit the qbasic editor.
REM
REM   Comments and Criticisms:  They are all very welcome.  Send to
REM                             MATHWEASEL@AOL.COM or via snail mail
REM                             to the address above.
REM
REM   NOTICE:  Copyright (c) 1995 Russell W. Dixon.  All Rights Reserved.
REM            Redistribution and use in source and binary forms are
REM            permitted provided that the above copyright notice and this
REM            paragraph are duplicated in all such forms.
REM            THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR  
REM            IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
REM            WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
REM            PURPOSE.

DECLARE SUB getkey ()
DECLARE SUB getfour ()
DECLARE SUB getbyte ()
DECLARE FUNCTION nextch$ ()
DECLARE SUB nextword (header$, word$, index!)
DECLARE SUB getheader (header$, outfilename$)
DECLARE SUB getoutfile ()
DECLARE SUB getinfile ()
DECLARE SUB init ()
DECLARE SUB decodeline ()
DECLARE SUB abort (message$)
DECLARE SUB nextline (s$)
DECLARE SUB terminate ()
DECLARE FUNCTION checkline! ()

COMMON SHARED suffix$, offset, line$, linenum, char(), bin$()
COMMON SHARED lineindex, bytenum, errflag, keypressed$

DIM char(3)
DIM bin$(2)
suffix$ = ".uue"
offset = 32

ON ERROR GOTO errhandler

CALL init
CALL nextline(line$)
DO WHILE (checkline)
  CALL decodeline
  CALL nextline(line$)
LOOP
CALL terminate
END

errhandler:
  SELECT CASE ERR
    CASE 53
      errflag = 1
      RESUME NEXT
    CASE 64
      errflag = 2
      RESUME NEXT
    CASE ELSE
      CLS
      PRINT "Unexpected error, ending program."
      PRINT "Error #"; ERR; ".  Please report to RDIXON"
      END
   END SELECT

SUB abort (message$)
  PRINT
  IF linenum > 0 THEN PRINT "Line "; linenum; ":"
  PRINT message$
  STOP
END SUB

FUNCTION checkline
 IF line$ = "" THEN CALL abort("Blank line in file.")
 checkline = NOT (LEFT$(line$, 1) = " " OR LEFT$(line$, 1) = "`")
END FUNCTION

SUB decodeline
  lineindex = 0
  bytenum = 3
  count = ASC(nextch$) - offset
  FOR loopi = 1 TO count
    CALL getbyte
  NEXT loopi
END SUB

SUB getbyte
  IF bytenum = 3 THEN CALL getfour
  PRINT #2, bin$(bytenum);
  bytenum = bytenum + 1
END SUB

SUB getfour
  FOR loopk = 0 TO 3
    char(loopk) = ASC(nextch$) - offset
  NEXT loopk
  bin$(0) = CHR$((char(0) * 4) MOD 256 + FIX(char(1) / 16))
  bin$(1) = CHR$((char(1) * 16) MOD 256 + FIX(char(2) / 4))
  bin$(2) = CHR$((char(2) * 64) MOD 256 + char(3))
  bytenum = 0
END SUB

SUB getheader (header$, outfilename$)
  header$ = header$ + " "
  index = 7
  CALL nextword(header$, mode$, index)
  CALL nextword(header$, outfilename$, index)
END SUB

SUB getinfile
  DO
    CLS
    PRINT
    PRINT
    PRINT "                                    UUDECV10.BAS"
    PRINT "                                    by Russell W. Dixon"
    PRINT "                                    mathweasel@aol.com"
    PRINT
    INPUT "  What is the name of the file to decode "; infilename$
    hasdot = 0
    FOR loopj = 1 TO LEN(infilename$)
      IF MID$(infilename$, loopj, 1) = "." THEN hasdot = 1
    NEXT loopj
    IF hasdot = 0 THEN infilename$ = infilename$ + suffix$
    errflag = 0
    OPEN infilename$ FOR INPUT AS #1
    IF errflag = 1 THEN
      PRINT
      PRINT "  File Not Found :  Press a key to continue"
      CALL getkey
    ELSE
      IF errflag = 2 THEN
        PRINT
        PRINT "  BAD Filename :  Press a key to continue"
        CALL getkey
      END IF
    END IF
  LOOP UNTIL (errflag = 0)
END SUB

SUB getkey
  keypressed$ = ""
  DO WHILE keypressed$ = ""
    keypressed$ = INKEY$
  LOOP
  keypressed$ = UCASE$(keypressed$)
END SUB

SUB getoutfile
  IF EOF(1) THEN CALL abort("Nothing to decode!")
  CALL nextline(header$)
  DO WHILE (NOT (LEFT$(header$, 6) = "begin " OR EOF(1)))
    CALL nextline(header$)
  LOOP
  PRINT
  IF EOF(1) THEN CALL abort("Nothing to decode.")
  CALL getheader(header$, outfilename$)
  errflag = 0
  OPEN outfilename$ FOR INPUT AS #2
  IF errflag = 0 THEN
    PRINT
    PRINT " WARNING:  File exists.  Overwrite ? ";
    CALL getkey
    PRINT keypressed$
    IF keypressed$ <> "Y" THEN
      CLOSE
      PRINT "  Program has ended!!"
      END
    ELSE
      CLOSE 2
    END IF
  END IF
  OPEN outfilename$ FOR OUTPUT AS #2
  PRINT
  PRINT "  The destination file is: "; outfilename$
END SUB

SUB init
 linenum = 0
 CALL getinfile
 CALL getoutfile
END SUB

FUNCTION nextch$
  lineindex = lineindex + 1
  IF lineindex > LEN(line$) THEN CALL abort("Line is short.")
  ch$ = MID$(line$, lineindex, 1)
  IF ch$ < " " OR ch$ > "`" THEN CALL abort("Illegal Character in line.")
  IF ch$ = "`" THEN nextch$ = " " ELSE nextch$ = ch$
END FUNCTION

SUB nextline (s$)
  linenum = linenum + 1
  LINE INPUT #1, s$
  LOCATE 10, 5
  PRINT "Currently decoding line: "; linenum
END SUB

SUB nextword (header$, word$, index)
  word$ = ""
  DO WHILE (MID$(header$, index, 1) = " ")
    index = index + 1
    IF index > LEN(header$) THEN CALL abort("Incomplete header.")
  LOOP
  DO WHILE (MID$(header$, index, 1) <> " ")
    word$ = word$ + MID$(header$, index, 1)
    index = index + 1
  LOOP
END SUB

SUB terminate
  IF EOF(1) THEN CALL abort("Abnormal end.")
  CALL nextline(trailer$)
  IF LEN(trailer$) < 3 THEN CALL abort("Abnormal end.")
  IF MID$(trailer$, 1, 3) <> "end" THEN CALL abort("abnormal end.")
  CLOSE (1)
  CLOSE (2)
  LOCATE 20
  PRINT
END SUB

