/*
 * 16:42:56 08/03/99
 *
 * AutoSave.java - Notifies text area to save its content
 * Copyright (C) 1999 Romain Guy
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.chez.powerteam.jext;

public class AutoSave extends Thread
{
  private static int interval;

   // Autosave simply extends Thread to make it easy to use

  public AutoSave()
  {
    super("----thread: autosave: jext----");
    setDaemon(true);
    start();
  }

 // Used by Jext to save the interval in a property file

  public static int getInterval()
  {
    return interval;
  }

  // This method is used by the Jext's menu items to set the autosave interval

  public static void setInterval(int newInterval)
  {
    interval = newInterval;
  }

  // When AutoSave starts we look for the Jext's autosave property
  // which is a string representation of an integer
  // The interval returned is converted in miliseconds and the Thread
  // sleeps during the interval. At the end, AutoSave call the Jext's
  // text area save method

  public void run()
  {
    try
    {
      interval = Integer.parseInt(Jext.getProperty("autosavedelay"));
    } catch(NumberFormatException nf) {
      interval = 60;
    }
    if (interval == 0) return;
    interval *= 1000;
    for(;;)
    {
      try
      {
        Thread.sleep(interval);
      }	catch(InterruptedException i) {
        return;
      }
      Jext.getTextArea().autoSave();
      if (interrupted()) return;
    }
  }
}

// End of AutoSave.java
