/*
 * 14:00:35 31/03/99
 *
 * CaretColor.java
 * Copyright (C) 1999 Romain Guy
 *
 * This free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.chez.powerteam.jext.menus;

import java.awt.Color;
import javax.swing.JColorChooser;
import com.chez.powerteam.jext.*;
import java.awt.event.ActionEvent;

public class CaretColor extends MenuAction
{
  public CaretColor()
  {
    super("CaretColor");
  }

  public void actionPerformed(ActionEvent evt)
  {
    Color color = JColorChooser.showDialog(getTextArea().getJextParent(), "Caret Color...", getTextArea().getCaretColor());
    if (color != null && !color.equals(Color.white))
    {
      getTextArea().setCaretColor(color);
      Jext.setProperty("caretcolor", getColorString(color));
    }
  }

  private String getColorString(Color c)
  {
    String colString = Integer.toHexString(c.getRGB() & 0xffffff);
    return "#000000".substring(0, 7 - colString.length()).concat(colString);
  }
}

// End of CaretColor.java
