/*
 * 18:34:24 25/03/99
 *
 * Expand.java
 * Copyright (C) 1999 Romain Guy
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.chez.powerteam.jext.menus;

import javax.swing.text.Element;
import com.chez.powerteam.jext.*;
import java.awt.event.ActionEvent;
import javax.swing.text.BadLocationException;

public class Expand extends MenuAction
{
  public Expand()
  {
    super("Expand");
  }

  public void actionPerformed(ActionEvent evt)
  {
    int dot = getTextArea().getSelectionStart();
    Element map = getTextArea().getDocument().getDefaultRootElement();
    int lineNo = map.getElementIndex(dot);
    Element lineElement = map.getElement(lineNo);
    int start = lineElement.getStartOffset();
    int len = lineElement.getEndOffset() - start - 1;
    String line;
    try
    {
      line = getTextArea().getDocument().getText(start, len);
      int wordStart = start;
loop: for (int i = dot - 1; i >= start; i--)
      {
        char c = line.charAt(i - start);
        switch(c)
        {
        case ' ':
        case '\t':
          wordStart = i + 1;
          break loop;
        default:
          if (!Character.isLetterOrDigit(c))
          {
            wordStart = i + 1;
            break loop;
          }
        }
      }
      if(wordStart == dot)
      {
        Utilities.beep();
        return;
      }
      String word = line.substring(wordStart - start, dot - start);
      for(int i = lineNo; i >= 0; i--)
      {
        lineElement = map.getElement(i);
        int lineStart = lineElement.getStartOffset();
        int lineLen = lineElement.getEndOffset() - lineStart - 1;
        if (i == lineNo) lineLen -= (dot - wordStart);
        line = getTextArea().getDocument().getText(lineStart, lineLen);
        int index = line.lastIndexOf(word);
        if (index != -1)
        {
          int wordEnd = lineLen;
loop2:    for (int j = index + 1; j < lineLen; j++)
          {
            char c = line.charAt(j);
            switch(c)
            {
            case ' ':
            case '\t':
              wordEnd = j;
              break loop2;
            default:
              if (!Character.isLetterOrDigit(c))
              {
                wordEnd = j;
                break loop2;
              }
            }
          }
          getTextArea().replaceSelection(line.substring(index + word.length(), wordEnd));
          return;
        }
      }
    } catch(BadLocationException ble) { }
    Utilities.beep();
  }
}

// End of Expand.java
