/*
 * 18:41:28 25/03/99
 *
 * TabsToSpaces.java
 * Copyright (C) 1999 Romain Guy
 *
 * This	free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.chez.powerteam.jext.menus;

import javax.swing.text.Element;
import com.chez.powerteam.jext.*;
import java.awt.event.ActionEvent;
import javax.swing.text.BadLocationException;

public class TabsToSpaces extends MenuAction
{
  public TabsToSpaces()
  {
    super("TabsToSpaces");
  }

  public void actionPerformed(ActionEvent evt)
  {
    try
    {
      JextTextArea textArea = getTextArea();
      textArea.beginCompoundEdit();
      Element map = textArea.getDocument().getDefaultRootElement();
      for (int i = 0; i < map.getElementCount(); i++)
      {
        Element lineElement = map.getElement(i);
        int start = lineElement.getStartOffset();
        int end = lineElement.getEndOffset() - 1;
        end -= start;
        int tabSize = getTextArea().getTabSize();
        String text = doTabsToSpaces(textArea.getText(start, end), tabSize);
        textArea.getDocument().remove(start, end);
        textArea.getDocument().insertString(start, text, null);
      }
      textArea.endCompoundEdit();
    }
    catch (BadLocationException ble) { }
  }

  private String doTabsToSpaces(String in, int tabSize)
  {
    StringBuffer buf = new StringBuffer();
    int width = 0;
    for (int i = 0; i < in.length(); i++)
    {
      switch (in.charAt(i))
      {
        case '\t':
          int count = tabSize - (width % tabSize);
          width += count;
          while(--count >= 0)
          buf.append(' ');
          break;
        case '\n':
          width = 0;
          buf.append(in.charAt(i));
          break;
        default:
          width++;
          buf.append(in.charAt(i));
          break;
      }
    }
    return buf.toString();
  }
}

// End of TabsToSpaces.java
