/*
 * 17:38:26 31/03/99
 *
 * WordCount.java
 * Copyright (C) 1999 Romain Guy
 *
 * This	free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package com.chez.powerteam.jext.menus;

import javax.swing.JOptionPane;
import com.chez.powerteam.jext.*;
import java.awt.event.ActionEvent;
import javax.swing.text.BadLocationException;

public class WordCount extends MenuAction
{
  public WordCount()
  {
    super("WordCount");
  }

  public void actionPerformed(ActionEvent evt)
  {
    String selection = getTextArea().getSelectedText();
    if (selection != null)
    {
      doWordCount(selection);
      return;
    }
    try
    {
      doWordCount(getTextArea().getText(0, getTextArea().getLength()));
    } catch(BadLocationException ble) { }
  }

  private void doWordCount(String text)
  {
    char[] chars = text.toCharArray();
    int characters = chars.length;
    int words;
    if (characters == 0)
      words = 0;
    else
      words = 1;
    int lines = 1;
    boolean word = false;
    for(int i = 0; i < chars.length; i++)
    {
      switch (chars[i])
      {
        case '\r': case '\n':
          lines++;
	  break;
        case ' ': case '\t':
          if (word)
          {
            words++;
            word = false;
          }
          break;
        default:
          word = true;
          break;
      }
    }
    Object[] args = { "Characters: " + String.valueOf(characters), "Words: " + String.valueOf(words), "Lines: " + String.valueOf(lines) };
    JOptionPane.showMessageDialog(getTextArea().getJextParent(), args, "Word Count", JOptionPane.INFORMATION_MESSAGE);
  }
}

// End of WordCount.java
